sealed abstract class Exp {
	def deriv:Exp = this match {
		case X() => Const(1)
		case Const(i) => Const(0)
		case Add(e1,e2) => Add(e1.deriv,e2.deriv)
		case Mul(e1,e2) => 
			Add(Mul(e1,e2.deriv),Mul(e1.deriv,e2))
	}
	def +(e:Exp) = Add(this,e)
	def *(e:Exp) = Mul(this,e)
}
case class X() extends Exp
case class Const(i:Int) extends Exp
case class Add(e1:Exp,e2:Exp) extends Exp
case class Mul(e1:Exp,e2:Exp) extends Exp

object Deriv extends App {
	val e = Mul(X(),X())
	println(e)
	println(e.deriv)
	val e1 = X()*X()
	println(e1)
	println(e1.deriv)
	val e2 = (X()+Const(1))*(X()+Const(1))
	println(e2)
	println(e2.deriv)
}
