sealed abstract class Exp {
	def eval(x:Int,y:Int):Int = this match {
		case X() => x
		case Y() => y
		case Const(i) => i
		case Add(e1:Exp,e2:Exp) => e1.eval(x,y) + e2.eval(x,y)
		case Mul(e1:Exp,e2:Exp) => e1.eval(x,y) * e2.eval(x,y)
	}
}
case class Const(i:Int) extends Exp
case class Add(e1:Exp,e2:Exp) extends Exp
case class Mul(e1:Exp,e2:Exp) extends Exp
case class X() extends Exp
case class Y() extends Exp

object Exp extends App {
	val c = Const(10)
	val a = Add(Const(10), Const(20))
	val m = Mul(Const(10), Const(20))
	val e = Add(X(),Const(1)) // e = x+1
	val e2 = Mul(X(),X()) // e = x*x
	val e3 = Mul(X(),Y()) // e = x*y
	println(c)
	println(a)
	println(m)
	println(e)
	println(e2)
	println(e3)
	println(c.eval(0,0)) // stampa 10
	println(a.eval(0,0)) // stampa 30
	println(m.eval(0,0)) // stampa 200
	println(e.eval(10,0))// stampa 11
	println(e2.eval(10,0))// stampa 100
	println(e3.eval(10,30))// stampa 300
}
